class CKlasse
{
    public:
        int x;
        int tuWas (int y)
        {
            return x+y;
        }
};

int main( int argc, char* (argv[]) )
{
    // Pointer (Zeiger) ******************************

    int  a = 42;
    int* b; // Zeiger auf Integer

    b = &a; // Der Zeiger b enthlt nun die Adresse der Variablen a.

    a  = 34 + 2*a;
    *b = 34 + 2*(*b); // Macht dasselbe! *b (also das, worauf b zeigt) ist
                      // jetzt mit a identisch.

    b = b+4; // jetzt zeigt b auf eine Adresse
             // vier Variablen vom Typ wie *b (nicht: Byte!) weiter oben.
             // Aber was ist da berhaupt?
    *b = 13; // FALSCH! Strzt aber selten ab.

    b = b+10000;
    *b = 13; // FALSCH! Strzt recht sicher ab.

    // eindimensionale Arrays ******************************

    int c[42];

    c[42] = 13; // FALSCH! Strzt aber selten ab.

    int* d;

    d = c; // Beim Zuweisen und Rechnen macht C keinen Unterschied zwischen
           // eindimensionalen Arrays von einem Typ und Zeigern auf diesen Typ.
           // Der Name eines Arrays steht fr einen Zeiger auf das erste Element.
           // Aber c = d; geht natrlich nicht: Die Adresse eines Arrays
           // ist unvernderlich!

    c[12]   = 34+c[13];
    *(d+12) = 34+*(d+13); // Macht dasselbe.
    d[12]   = 34+d[13]; // Wenn Zeiger und Arrays schon so hnlich sind ...

    int* e;
    *(e+12) = 0; // FALSCH! Strzt aber selten ab.
                 // Nur den Zeiger anzulegen, reserviert noch keinen Speicher.
                 // Auerdem kann der Zeiger sonstwohin zeigen.

    // mehrdimensionale Arrays ******************************

    int f[3][4];
    int* g = f[2]; // Pointer auf das Array aus f[2][...].

    f[2][1]= 5+f[2][3];
    *(g+1) = 5+*(g+3); // Macht dasselbe.

    int (*h)[4] = f; // Zeigt auf das Array. (Zeiger auf Array mit vier "int".)

    h[2][1]     = 5 + h[2][3];
    *(*h+2*4+1) = 5 + *(*h+2*4+3); // Macht dasselbe.

    // Zeiger auf Objekte ******************************

    CKlasse i;
    CKlasse* j;

    j = &i; // Pointer j zeigt auf Objekt i.

    (*j).x = (*j).tuWas(3);
    j->x   =  j->tuWas(3); // Macht dasselbe,   xyz->uvw   steht fr   (*xyz).uvw

    CKlasse* k;
    k->tuWas(3); //FALSCH! Zeigt ins Nirvana, nicht auf ein Objekt.

    CKlasse l[2][3];  // Element-Objekte des Array
                      // werden anders als in Java sofort konstruiert!
    l[1][2].tuWas(3); // Kann man also machen.

    return 0;
}
