// Zeiger an Funktionen bergeben ******************

void tausche ( int* x, int* y )
{
    int z = *x;
    *x = *y;
    *y = z;
}

void rufeDasAuf1 ( void )
{
    int a = 3;
    int b = 4;
    tausche( &a, &b ); // Jetzt ist a gleich 4 und b gleich 3.
}

int* test1 (void)
{
    int x;
    return &x; // FEHLER! Nach Ende der Funktion ist
               // der Inhalt der Adresse von x vogelfrei.
               // Siehe Warnung des Compilers.
}

// Arrays bergeben ******************

void test2 (int a[][5][4]) // Nur erste Dimension darf man weglassen.
{
    // Das Programm kann nicht ohne Weiteres feststellen,
    // wie gro das Array ist!
    a[1][2][3] = 6;
}

void rufeDasAuf2 ( void )
{
    int b[3][5][4];
    b[1][2][3] = 5;
    test2(b);
    // b[1][2][3] ist jetzt 6.
    // Die Methode erhlt einen Zeiger und ndert das Array hier.
}

int (* (test3 (int a[][5][4]) ) )[5][4] // Rckgabe eines Zeigers
                                        // auf ein dreidim. (!) Array
{
    return a;
}

// Objekte bergeben ******************

class CTest
{
    public:
        int x;
};

void test4 (CTest a) // a wird als Kopie des Parameters konstruiert.
{
    a.x = 3;
}

void rufeDasAuf3 (void)
{
    CTest b;
    b.x = 2;
    test4(b);
    // b.x ist weiter 2. Anders als bei Java!
    // Java bergibt nur die elementaren Typen
    // wie int als Kopie, den Rest als Referenz.
}

CTest test5 (void) // Rckgabe eines Objekts
{
    CTest a;
    return a; // Objekt wird nach Funktionsende automatisch zerstrt.
}

void rufeDasAuf4 (void)
{
    CTest b = test5(); // Geht, weil das (zuvor kopierte) Objekt lebt,
                       // bis "=" beendet ist.

    CTest c;
    c = test5();       // Genauso.

    CTest* d;
    d = &test5();      // FEHLER! d zeigt auf ein zerstrtes Objekt.
                       // Mit elementaren Typen ist so ein Ausdruck
                       // schon syntaktisch verboten.
}

int main( int argc, char* (argv[]) )
{
    return 0;
}
