#include <new> // inzwischen ohne .h, aber dafr namespace std ntig
#include <cstdlib> // ditto

using namespace std;

class CTest
{
    public:
        int x;
        void tuWas (void)
        {
        }
};

int main( int argc, char* (argv[]) )
{
    // *****************************************************************
    // dynamische Speicherverwaltung in C++ mit new, delete und delete[]

    CTest* a;

    try
    {
        a = new CTest; // Objekt dynamisch anlegen
                       // Java will   new CTest();   mit Klammern

        // Frher musste man checken, ob a == NULL,
        // sonst war nicht genug Speicher frei. Heute wirft new gem
        // ISO/ANSI-Standard eine Exception. Um das alte Verhalten zu
        // erzwingen, kann man new(nothrow) verwenden.

        // ACHTUNG!!! Microsoft Visual C++ richtet sich auch in Version 6
        // anders als GCC noch nicht nach dem Standard, sondern liefert NULL,
        // statt eine Exception zu werfen.
    }
    catch (bad_alloc a)
    {
        return 42; // besser wre: Fehlerbehandlung
    }

    a->tuWas(); // Objekt verwenden
    // Hier msste man eigentlich Exception oder a==NULL checken.
    delete a; // dynamisch angelegte Objekte muss man eigenhndig zerstren.
              // Java macht das selbst!
    // delete steht meist am Ende der Funktion
    // oder wird beim Zerstren des Objekts aufgerufen (Destruktor).



    int* b;
    b = new int(3); // int dynamisch anlegen und mit Wert 3 initialisieren;
                    // entsprechend mit Konstruktoraufruf bei new fr Objekte
    // ... damit arbeiten und dann:
    delete b;



    CTest* c = new CTest[4]; // Array dynamisch anlegen ...
    // ... damit arbeiten und dann ...
    delete[] c; // ... abbauen. Beachte [] !

    int x = 7;
    CTest* d = new CTest[x]; // Dynamisch gehts auch mit variabler Gre ...
    delete[] d;

    CTest (*e)[3][4] = new CTest[x][3][4]; // ... aber nur in der 1. Dimension.
    delete[] e;



    CTest* f = new CTest;
    // ... damit arbeiten und dann:
    delete f;
    // f->x = 13; // FEHLER! Objekt ist zerstrt. Schmiert aber meist nicht ab.
    // delete f; // FEHLER! Man kann Objekt nicht zweimal zerstren.

    // Die bessere Lsung:
    CTest* g = new CTest;
    // ... damit arbeiten und dann:
    delete g; g = NULL; // Mit dem delete sofort Zeiger auf NULL setzen.
    // g->x = 13; // FEHLER! Schmiert aber sofort ab. (Sicherer!)
    delete g; // macht nichts, wenn g == NULL



    // ****************************************************************
    // dynamische Speicherverwaltung in C (und C++) mit malloc und free,
    // sind deklariert in malloc.h

    int* h = (int*)malloc(10000*sizeof(int)); // Platz fr 10000 Integer
                                              // Ggf. mit Bytemll belegt!
    if (h == NULL) // Nicht genug Speicher zu haben.
    {
        return 42; // beenden und Fehler zurckmelden
    }
    h[3467] = 13;
    free(h);



    int* i = (int*)calloc(10000, sizeof(int)); // Platz fr 10000 Integer
                                               // mit Nullen gefllt.
                                               // Komma beachten!
    if (i == NULL) // Nicht genug Speicher zu haben.
    {
        return 42;
    }
    i[3467] = 13;
    free(i);



    int* j = (int*)malloc(10000*sizeof(int)); // Platz fr 10000 Integer
    if (j == NULL) // Nicht genug Speicher zu haben.
    {
        return 42;
    }
    j[3467] = 13;
    int* k = (int*)realloc(j, 20000); // Wollen nachtrglich 20000 Integer.
                                      // Verringerung ginge auch.
    if (k == NULL) // Nicht genug Speicher zu haben.
    {
        // j zeigt jetzt immer noch auf die 10000 Integer.
    }
    // k zeigt jetzt auf 20000 Integer. Die ersten 10000
    // wurden ggf. umkopiert, das heit k[3456] ist 13.

    // j[3467] = 13; // FEHLER! Block ist ggf. verschoben. Aber selten Absturz.
    k[3467] = 13; // o.k.
    // free(j); // FEHLER! Aber selten Absturz.
    free(k); // o.k. und auch ntig


    return 0;
}
