/* Konstanten *****************************************/

#define MAXZAHL_KLASSISCH 1000

const int MAXZAHL_CPLUSPLUS = 1000; // vergleiche final in Java

int main( int argc, char* (argv[]) )
{
    // Konstanten

    int x = 1000;
    x++;
    int a[x]; // FEHLER! Compiler braucht feste Gre, um Speicher zu reservieren.
              // gcc (und damit Dev-C++) kann das allerdings auch so.

    MAXZAHL_KLASSISCH++; // FEHLER! schon syntaktisch falsch
    int b[MAXZAHL_KLASSISCH]; // typische Lsung fr C

    MAXZAHL_CPLUSPLUS++; // FEHLER! const-Variablen drfen nur gelesen werden.
    int c[MAXZAHL_CPLUSPLUS]; // typische Lsung fr C++

    return 0;
}



class CTest
{
    public:
        int x;
        void tuWas (void)
        {
            x = 1;
        }
        void tuWasConst (void) const // Versprechen, das Objekt nicht zu verndern.
                                     // Der Compiler passt ausnahmsweise ;-) auf!
        {
            x = 1; // FEHLER! Compiliert nicht.
        }
};

void test1 (const CTest* a) // Das Objekt, auf welches das Argument zeigt,
                            // darf nicht verndert werden.
{
    int b = a->x; // o.k.
    a->tuWasConst(); // o.k.
    a->x = 42; // FEHLER! Compiliert nicht.
    a->tuWas(); // FEHLER! Compiliert nicht.
}

const CTest* test2 (void) // Das Objekt, auf das der zurckgegebene Pointer zeigt,
                          // kann nicht (ohne Tricks) verndert werden.
{
    CTest* a = new CTest; // Achtung: Irgendwo muss dieses Objekt wieder zerstrt werden.
    return a;
}
