/* Referenzen *****************************************/

// Referenzen sind eine Neuerung von C++ gegenber C.
// Im Allgemeinen sollte man sie Zeigern vorziehen,
// z.B. weil sie nicht ins Nirvana zeigen knnen.

// Eine Referenz verhlt sich wie ein anderer Name fr dasselbe Objekt.

int main(int argc, char *(argv[]))
{
    int a = 3;
    int& b = a; // "Referenz" b ist jetzt ein anderer Name fr a
                // und immer nur fr a.
    int* c = &a; // Zum Vergleich: mit Zeiger. Der kann auch
                 // umgebogen werden.

    a = 7*a;
    b = 7*b; // Macht dasselbe.

    int d = 4;
    b = d; // b hat jetzt den Wert 4, also auch a.
    d = 5; // immer noch

    return 0;
}

void tausche (int& a, int& b)
{
    int c = a;
    a = b;
    b = c;
}

void test1 (void)
{
    int x = 2;
    int y = 3;
    tausche (x,y); // Jetzt ist y gleich 2 und x gleich 3.
}

// typische Art, groe Objekte zu bergeben:

class CTest
{
    public:
    int x;
};

CTest& zweiundvierzig (CTest& a)
{
    a.x = 42;
    return a;
}

void test2 (void)
{
    CTest b;
    CTest& c = zweiundvierzig (b);
}

CTest& test3 (void)
{
    CTest d;
    return d; // FEHLER! Nach Ende der Funktion ist das Objekt zerstrt
              // und die Referenz damit unbrauchbar,
              // kein Problem dagegen bei Rckgabetyp CTest statt CTest&
}
